=== debian/changelog ===
gvm-libs (22.30.0-1) unstable; urgency=medium

  * New upstream version 22.30.0
  * Refresh patches
  * Update symbols
  * Udpate debian/watch to Version 5

 -- Sophie Brun <sophie@kali.org>  Thu, 30 Oct 2025 18:09:12 +0100
