=== debian/rules ===
#!/usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# only build the tests if cgreen is present
BUILD_TEST := $(shell if [ -e /usr/include/cgreen/cgreen.h ]; then echo 'yes'; else echo 'no'; fi)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		-DBUILD_WITH_LDAP=ON \
		-DBUILD_WITH_RADIUS=yes \
		-DBUILD_TESTS=$(BUILD_TEST) \
		$(NULL)

# Architecture: all only: build the doxygen documentation
override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc
endif

# doxygen documentation is installed using dh_installdocs
override_dh_auto_install-indep:

# don't run test when we build only the doc
override_dh_auto_test-indep:

override_dh_auto_test-arch:
ifeq ($(BUILD_TEST),yes)
	dh_auto_build -- tests
	dh_auto_test
endif

override_dh_missing:
	dh_missing --fail-missing
